#include <iostream>
#include <fstream>
#include <cstring>
#include <iomanip>
#include "textFiles.h"
using namespace std;

//Problem 1
double findAvarageInStream(istream& stream)
{
	double sum = 0;
	int count = 0;

	while (stream.good())
	{
		double number;

		stream >> number;

		if (stream)
		{
			sum += number;
			++count;
		}
	}

	double average = count ? sum / count : -1;

	return average;
}

//Problem 2
//Enter any symbol, different from a digit to stop input.
istream& operator>>(istream& stream, Stack& stack)
{
	while (stream)
	{
		int x;
		stream >> x;

		if (stream)
		{
			stack.push(x);
		}
	}

	return stream;
}

ostream& operator<<(ostream& stream, Stack& stack)
{
	stream << "[";
	while (!stack.empty())
	{
		int top = stack.pop();

		stream << top;

		if (stack.empty())
		{
			stream << "]";
		}
		else
		{
			stream << ", ";
		}
	}

	return stream;
}

//Problem 3
void copyTextFile(const char* fileName)
{
	ifstream in(fileName, ios::in);
	ofstream out("copied.txt", ios::out);

	while (!in.eof())
	{
		char ch = in.get();
		out << ch;
	}
}

//Problem 4
void formatValues()
{
	cout << setprecision(5) << 2.35 << endl << -4.768945 << endl;

	cout << setiosflags(ios::right) << setw(20) << 65300 << endl;

	cout << showpos << 5 << endl;

	cout.unsetf(ios::showpos);

	cout << 5 << endl;
}

//Problem 5
int longestLine(const char* fileName)
{
	ifstream in(fileName, ios::in);

	int max = -1;
	int maxIndex = -1;
	int currentLine = 0;

	while (!in.eof())
	{
		int currentLineLength = 0;
		char ch = in.get();

		while (ch != '\n' && !in.eof())
		{
			++currentLineLength;
			ch = in.get();
		}

		if (currentLineLength > max)
		{
			max = currentLineLength;
			maxIndex = currentLine;
		}

		++currentLine;
	}

	return maxIndex;
}

//Problem 6
void countChars(const char* source, int* counts)
{
	for(int i=0; i < 256; ++i)
	{
		counts[i] = 0;
	}

	ifstream in(source, ios::in);

	while (!in.eof())
	{
		char ch = in.get();


		if (!in.eof())
		{
			++counts[ (int) ch ];
		}
	}
}

//Problem 7
void removeIntervals(const char* source, const char* dest)
{
	ifstream in(source, ios::in);
	ofstream out(dest, ios::out);

	while (!in.eof())
	{
		char ch = in.get();
		
		if (ch != ' ')
		{
			out << ch;
		}
	}
}